> ## Documentation Index
> Fetch the complete documentation index at: https://docs.pdf.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Return HTML Template by ID

> Returns HTML template by template’s id.

## `GET /templates/html/:id`

Once you have obtained a template then use the [PDF from HTML](/api-reference/pdf-from-html) API with the required `templateId` & `templateData` parameters defined.

Use the dashboard to manage your [HTML to PDF Templates](https://app.pdf.co/html-templates-tool).

## Query parameters

*No query parameters accepted.*

## Responses

| Parameter          | Type    | Description                                |
| ------------------ | ------- | ------------------------------------------ |
| `id`               | integer | Template ID.                               |
| `type`             | string  | Template type.                             |
| `title`            | string  | Template title.                            |
| `description`      | string  | Template description.                      |
| `test_json`        | string  | Template test JSON.                        |
| `updated_at`       | string  | Template updated at.                       |
| `body`             | string  | Template content.                          |
| `remainingCredits` | integer | Number of credits remaining in the account |
| `credits`          | integer | Number of credits consumed by the request  |

## `Example` Payload

<Note>To see the request size limits, please refer to the [Request Size Limits](/api-reference/url-input-and-request-limits#pdf-co-request-size).</Note>

## `Example` Response

<Note>To see the main response codes, please refer to the [Response Codes](/api-reference/response-codes) page.</Note>

```json theme={null}
{
  "templates": [
    {
      "id": 1,
      "type": "system",
      "title": "General Invoice Template",
      "description": "sample invoice template showcasing use of Mustache templates syntax for generating invoices"
    },
    {
      "id": 15,
      "type": "user",
      "title": "User Template 1",
      "description": ""
    }
  ],
  "remainingCredits": 99204004,
  "credits": 2
}
```

<Note>
  **Inconsistent URL Encoding in cURL Output:** When using cURL to make API requests, the output JSON may show URL characters encoded as Unicode escape sequences. For example, the ampersand character (`&`) may appear as `\u0026` in the cURL output. This is normal JSON encoding behavior and does not affect the validity of the URL. The URL will function correctly when used, as JSON parsers automatically decode these escape sequences. If you're parsing the response programmatically, your JSON parser will handle this conversion automatically.
</Note>

## Code Samples

<Tabs>
  <Tab title="CURL">
    ```bash theme={null}
    curl --location --request GET 'https://api.pdf.co/v1/templates/html' \
    --header 'Content-Type: application/json' \
    --header 'x-api-key: '
    ```
  </Tab>

  <Tab title="JavaScript/Node.js">
    ```javascript theme={null}
    var https = require("https");
    var path = require("path");
    var fs = require("fs");


    // The authentication key (API Key).
    // Get your own by registering at https://app.pdf.co
    const API_KEY = "***********************************";


    // Data to fill the template
    const templateData = "./invoice_data.json";
    // Destination PDF file name
    const DestinationFile = "./result.pdf";

    /* 
    Please follow below steps to create your own HTML Template and get "templateId". 
    1. Add new html template in app.pdf.co/templates/html
    2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/pdfdotco/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    3. Save this new template
    4. Copy it’s ID to clipboard
    5. Now set ID of the template into “templateId” parameter
    */

    // HTML template using built-in template
    // see https://app.pdf.co/templates/html/2/edit
    const template_id = 2;


    // Prepare request to `HTML To PDF` API endpoint
    var queryPath = `/v1/pdf/convert/from/html?name=${path.basename(DestinationFile)}&async=True`;
    var reqOptions = {
        host: "api.pdf.co",
        path: encodeURI(queryPath),
        method: "POST",
        headers: {
            "x-api-key": API_KEY,
            "Content-Type": "application/json"
        }
    };


    var requestBody = JSON.stringify({
        "templateId": template_id,
        "templateData": fs.readFileSync(templateData, "utf8"),
        "async": true
    });
    // Send request
    var postRequest = https.request(reqOptions, (response) => {
        response.on("data", (d) => {
            // Parse JSON response
            var data = JSON.parse(d);        
            if (data.error == false) {
                console.log(`Job #${data.jobId} has been created!`);
                checkIfJobIsCompleted(data.jobId, data.url);
            }
            else {
                // Service reported error
                console.log(data.message);
            }
        });
    }).on("error", (e) => {
        // Request error
        console.log(e);
    });

    // Write request data
    postRequest.write(requestBody);
    postRequest.end();


    function checkIfJobIsCompleted(jobId, resultFileUrl) {
        let queryPath = `/v1/job/check`;

        // JSON payload for api request
        let jsonPayload = JSON.stringify({
            jobid: jobId
        });

        let reqOptions = {
            host: "api.pdf.co",
            path: queryPath,
            method: "POST",
            headers: {
                "x-api-key": API_KEY,
                "Content-Type": "application/json",
                "Content-Length": Buffer.byteLength(jsonPayload, 'utf8')
            }
        };

        // Send request
        var postRequest = https.request(reqOptions, (response) => {
            response.on("data", (d) => {
                response.setEncoding("utf8");

                // Parse JSON response
                let data = JSON.parse(d);
                console.log(`Checking Job #${jobId}, Status: ${data.status}, Time: ${new Date().toLocaleString()}`);

                if (data.status == "working") {
                    // Check again after 3 seconds
            setTimeout(function(){ checkIfJobIsCompleted(jobId, resultFileUrl);}, 3000);
                }
                else if (data.status == "success") {
                    // Download PDF file
                    var file = fs.createWriteStream(DestinationFile);
                    https.get(resultFileUrl, (response2) => {
                        response2.pipe(file)
                            .on("close", () => {
                                console.log(`Generated PDF file saved as "${DestinationFile}" file.`);
                            });
                    });
                }
                else {
                    console.log(`Operation ended with status: "${data.status}".`);
                }
            })
        });
        
        // Write request data
        postRequest.write(jsonPayload);
        postRequest.end();
    }
    ```
  </Tab>

  <Tab title="Python">
    ```python theme={null}
    import os
    import requests # pip install requests

    # The authentication key (API Key).
    # Get your own by registering at https://app.pdf.co
    API_KEY = "***********************************************"

    # Base URL for PDF.co Web API requests
    BASE_URL = "https://api.pdf.co/v1"

    # --HTML Template ID--
    # Please follow below steps to create your own HTML Template and get "templateId". 
    # 1. Add new html template in app.pdf.co/templates/html
    # 2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/pdfdotco/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    # 3. Save this new template
    # 4. Copy it’s ID to clipboard
    # 5. Now set ID of the template into “templateId” parameter

    # HTML template using built-in template
    # see https://app.pdf.co/templates/html/2/edit
    template_id = 2


    # Data to fill the template
    file_read = open(".\\invoice_data.json", mode='r')
    TemplateData = file_read.read()
    file_read.close()

    # Destination PDF file name
    DestinationFile = ".\\result.pdf"


    def main(args = None):
        GeneratePDFFromTemplate(template_id, TemplateData, DestinationFile)


    def GeneratePDFFromTemplate(template_id, templateData, destinationFile):
        """Converts HTML to PDF using PDF.co Web API"""

        data = {
            'templateData': templateData,
            'templateId': template_id
        }

        # Prepare URL for 'HTML To PDF' API request
        url = "{}/pdf/convert/from/html?name={}".format(
            BASE_URL,
            os.path.basename(destinationFile)
        )

        # Execute request and get response as JSON

        response = requests.post(url, data=data, headers={ "x-api-key": API_KEY })
        if (response.status_code == 200):
            json = response.json()

            if json["error"] == False:
                #  Get URL of result file
                resultFileUrl = json["url"]            
                # Download result file
                r = requests.get(resultFileUrl, stream=True)
                if (r.status_code == 200):
                    with open(destinationFile, 'wb') as file:
                        for chunk in r:
                            file.write(chunk)
                    print(f"Result file saved as \"{destinationFile}\" file.")
                else:
                    print(f"Request error: {response.status_code} {response.reason}")
            else:
                # Show service reported error
                print(json["message"])
        else:
            print(f"Request error: {response.status_code} {response.reason}")

    if __name__ == '__main__':
        main()
    ```
  </Tab>

  <Tab title="C#">
    ```csharp theme={null}
    using System;
    using System.Collections.Generic;
    using System.IO;
    using System.Net;
    using Newtonsoft.Json;
    using Newtonsoft.Json.Linq;

    namespace PDFcoApiExample
    {
      class Program
      {
        // The authentication key (API Key).
        // Get your own by registering at https://app.pdf.co
        const String API_KEY = "***********************************";

        static void Main(string[] args)
        {
          // --TemplateID--
          /* 
            Please follow below steps to create your own HTML Template and get "templateId". 
            1. Add new html template in app.pdf.co/templates/html
            2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/pdfdotco/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
            3. Save this new template
            4. Copy it’s ID to clipboard
            5. Now set ID of the template into “templateId” parameter
          */

          // HTML template using built-in template
          // see https://app.pdf.co/templates/html/2/edit
          var templateId = 2;

          // Data to fill the template
          string templateData = File.ReadAllText(@".\invoice_data.json");
          // Destination PDF file name
          string destinationFile = @".\result.pdf";

          // Create standard .NET web client instance
          WebClient webClient = new WebClient();

          // Set API Key
          webClient.Headers.Add("x-api-key", API_KEY);

          webClient.Headers.Add("Content-Type", "application/json");

          try
          {
                    // URL for `HTML to PDF` API call
            string url = Uri.EscapeUriString(string.Format(
              "https://api.pdf.co/v1/pdf/convert/from/html?name={0}", 
              Path.GetFileName(destinationFile)));

            // Prepare requests params as JSON
            Dictionary<string, object> parameters = new Dictionary<string, object>();
            parameters.Add("name", Path.GetFileName(destinationFile));
            parameters.Add("templateId", templateId);
            parameters.Add("templateData", templateData);

            // Convert dictionary of params to JSON
            string jsonPayload = JsonConvert.SerializeObject(parameters);

                    // Execute request
            string response = webClient.UploadString(url, jsonPayload);

                  // Parse JSON response
                  JObject json = JObject.Parse(response);

                  if (json["error"].ToObject<bool>() == false)
                  {
                    // Get URL of generated PDF file
                    string resultFileUrl = json["url"].ToString();

                    webClient.Headers.Remove("Content-Type"); // remove the header required for only the previous request

                    // Download the PDF file
              webClient.DownloadFile(resultFileUrl, destinationFile);

              Console.WriteLine("Generated PDF document saved as \"{0}\" file.", destinationFile);
                  }
                  else
                  {
                    Console.WriteLine(json["message"].ToString());
                  }
                }
                catch (WebException e)
                {
                  Console.WriteLine(e.ToString());
                }

          webClient.Dispose();


                Console.WriteLine();
                Console.WriteLine("Press any key to exit...");
                Console.ReadKey();
        }
      }
    }
    ```
  </Tab>

  <Tab title="Java">
    ```java theme={null}
    package com.company;

    import com.google.gson.JsonObject;
    import com.google.gson.JsonParser;
    import com.google.gson.JsonPrimitive;
    import okhttp3.*;

    import java.io.*;
    import java.net.*;
    import java.nio.file.Files;
    import java.nio.file.Path;
    import java.nio.file.Paths;

    public class Main
    {
        // The authentication key (API Key).
        // Get your own by registering at https://app.pdf.co
        final static String API_KEY = "***********************************";


        public static void main(String[] args) throws IOException
        {
            /* 
                Please follow below steps to create your own HTML Template and get "templateId". 
                1. Add new html template in app.pdf.co/templates/html
                2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/pdfdotco/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
                3. Save this new template
                4. Copy it’s ID to clipboard
                5. Now set ID of the template into “templateId” parameter
            */

            // HTML template using built-in template
            // see https://app.pdf.co/templates/html/2/edit
            final String templateId = "2";
            
            // Data to fill the template
            final String templateData = new String(Files.readAllBytes(Paths.get(".\\invoice_data.json")));
            // Destination PDF file name
            final Path destinationFile = Paths.get(".\\result.pdf");

            // Create HTTP client instance
            OkHttpClient webClient = new OkHttpClient();

            // Prepare URL for `HTML to PDF` API call
            String query = String.format(
                    "https://api.pdf.co/v1/pdf/convert/from/html?name=%s",
                    destinationFile.getFileName());

            // Make correctly escaped (encoded) URL
            URL url = null;
            try
            {
                url = new URI(null, query, null).toURL();
            }
            catch (URISyntaxException e)
            {
                e.printStackTrace();
            }

            // Prepare request body in JSON format
            JsonObject jsonBody = new JsonObject();
            jsonBody.add("templateId", new JsonPrimitive(templateId));
            jsonBody.add("templateData", new JsonPrimitive(templateData));

            RequestBody body = RequestBody.create(MediaType.parse("application/json"), jsonBody.toString());

            // Prepare request
            Request request = new Request.Builder()
                    .url(url)
                    .addHeader("x-api-key", API_KEY) // (!) Set API Key
                    .addHeader("Content-Type", "application/json")
                    .post(body)
                    .build();
            // Execute request
            Response response = webClient.newCall(request).execute();

            if (response.code() == 200)
            {
                // Parse JSON response
                JsonObject json = new JsonParser().parse(response.body().string()).getAsJsonObject();

                boolean error = json.get("error").getAsBoolean();
                if (!error)
                {
                    // Get URL of generated PDF file
                    String resultFileUrl = json.get("url").getAsString();

                    // Download PDF file
                    downloadFile(webClient, resultFileUrl, destinationFile.toFile());

                    System.out.printf("Generated PDF file saved as \"%s\" file.", destinationFile.toString());
                }
                else
                {
                    // Display service reported error
                    System.out.println(json.get("message").getAsString());
                }
            }
            else
            {
                // Display request error
                System.out.println(response.code() + " " + response.message());
            }
        }

        public static void downloadFile(OkHttpClient webClient, String url, File destinationFile) throws IOException
        {
            // Prepare request
            Request request = new Request.Builder()
                    .url(url)
                    .build();
            // Execute request
            Response response = webClient.newCall(request).execute();

            byte[] fileBytes = response.body().bytes();

            // Save downloaded bytes to file
            OutputStream output = new FileOutputStream(destinationFile);
            output.write(fileBytes);
            output.flush();
            output.close();

            response.close();
        }
    }
    ```
  </Tab>

  <Tab title="PHP">
    ```php theme={null}
    <!DOCTYPE html>
    <html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>PDF Invoice Generation Results</title>
    </head>
    <body>

    <?php 

    // Get submitted form data
    $apiKey = $_POST["apiKey"]; // The authentication key (API Key). Get your own by registering at https://app.pdf.co

    // Prepare URL for HTML to PDF API call
    $url = "https://api.pdf.co/v1/pdf/convert/from/html";

    // Prepare requests params
    $parameters = array();
    $parameters["name"] = "result.pdf";

    /* 
    Please follow below steps to create your own HTML Template and get "templateId". 
    1. Add new html template in app.pdf.co/templates/html
    2. Copy paste your html template code into this new template. Sample HTML templates can be found at "https://github.com/pdfdotco/pdf-co-api-samples/tree/master/PDF%20from%20HTML%20template/TEMPLATES-SAMPLES"
    3. Save this new template
    4. Copy it’s ID to clipboard
    5. Now set ID of the template into “templateId” parameter
    */

    // HTML template using built-in template
    // see https://app.pdf.co/templates/html/1/edit
    $parameters["templateId"] = 1;

    // Data to fill the template
    $templateData = file_get_contents("./invoice_data.json");
    $parameters["templateData"] = $templateData;

    // Create Json payload
    $data = json_encode($parameters);

    // Create request
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_HTTPHEADER, array("x-api-key: " . $apiKey, "Content-type: application/json"));
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $data);

    // Execute request
    $result = curl_exec($curl);

    if (curl_errno($curl) == 0)
    {
        $status_code = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        
        if ($status_code == 200)
        {
            $json = json_decode($result, true);
            
            if (!isset($json["error"]) || $json["error"] == false)
            {
                $resultFileUrl = $json["url"];
                
                // Display link to the file with conversion results
                echo "<div><h2>Conversion Result:</h2><a href='" . $resultFileUrl . "' target='_blank'>" . $resultFileUrl . "</a></div>";
            }
            else
            {
                // Display service reported error
                echo "<p>Error: " . $json["message"] . "</p>"; 
            }
        }
        else
        {
            // Display request error
            echo "<p>Status code: " . $status_code . "</p>"; 
            echo "<p>" . $result . "</p>";
        }
    }
    else
    {
        // Display CURL error
        echo "Error: " . curl_error($curl);
    }

    // Cleanup
    curl_close($curl);


    ?>

    </body>
    </html>
    ```
  </Tab>
</Tabs>
